#!/bin/sh
#Creates icons subtree under a given directory, resizing a given icon.
#Usage:
# generate_icons.sh image directoryroot

ensuredir(){
    echo "Ensuring $1"
    if [ ! -d "$1" ]; then
        mkdir -p $1
        echo "Created $1"
    fi
}


echo "${2}"
if [ ! -d "${2}" ]; then
    echo "Dest dir doesn't exist"
    exit 1
fi
f=$(pwd)
d=$(cd "${2}"; pwd)
icons="${d}/icons"
ios="${icons}/ios"
android="${icons}/android"
osx="${icons}/osx"
echo ${f}
echo ${icons}

ensuredir "${ios}" 
ensuredir "${android}/drawable-hdpi" 
ensuredir "${android}/drawable-mdpi" 
ensuredir "${android}/drawable-ldpi" 
ensuredir "${osx}" 

#sips --resampleWidth 512 "${f}/${1}" --out "${ios}/iTunesArtwork"
#sips --resampleWidth 1024 "${f}/${1}" --out "${ios}/iTunesArtwork@2x"
sips --resampleWidth 57 "${f}/${1}" --out "${ios}/Icon.png"
sips --resampleWidth 114 "${f}/${1}" --out "${ios}/Icon@2x.png"
sips --resampleWidth 114 "${f}/${1}" --out "${ios}/Icon-114.png"
sips --resampleWidth 29 "${f}/${1}" --out "${ios}/Icon-Small.png"
sips --resampleWidth 58 "${f}/${1}" --out "${ios}/Icon-Small@2x.png"
sips --resampleWidth 50 "${f}/${1}" --out "${ios}/Icon-Small-50.png"
sips --resampleWidth 72 "${f}/${1}" --out "${ios}/Icon-72.png"
sips --resampleWidth 144 "${f}/${1}" --out "${ios}/Icon-72@2x.png"
sips --resampleWidth 144 "${f}/${1}" --out "${ios}/Icon-144.png"

cp Default.png "${ios}"

sips --resampleWidth 72 "${f}/${1}" --out "${android}/drawable-hdpi/icon.png"
sips --resampleWidth 48 "${f}/${1}" --out "${android}/drawable-mdpi/icon.png"
sips --resampleWidth 36 "${f}/${1}" --out "${android}/drawable-ldpi/icon.png"

#cp -r ${icons} ${f}/../../
