package  
{
    import loom.gameframework.TimeManager;
    import loom.platform.Mobile;
    import loom2d.display.Image;
    import loom2d.display.Stage;
    import loom2d.textures.Texture;
    import loom2d.math.Color;

    /**
     * Displays a splash screen and uses the provided callback
     * to load the rest of the application.
     */
    public class SplashLoader 
    {
        private static var _splash:Image;
        
        public static function init(imagename:String, stage:Stage, time_manager:TimeManager, callback:Function) 
        {
            Mobile.allowScreenSleep(false);
            _splash = new Image(Texture.fromAsset(imagename));
            _splash.x = (stage.stageWidth-_splash.width)/2;
            _splash.y = (stage.stageHeight-_splash.height)/2;
            stage.color = new Color(255, 255, 255, 255).toInt();
            stage.addChild(_splash);
            time_manager.callLater(loaded, [callback]);
        }
        
        private static function loaded(callback:Function)
        {
            _splash.texture.dispose();
            _splash.removeFromParent(true);
            _splash = null;
            Mobile.allowScreenSleep(true);
            callback();
        }
        
    }
}
