package com.rockethands
{
    import loom.platform.UserDefault;
    import constants.*;
    import system.JSON;

    public class SaveGame
    {
        private var _save_key: String;
        private var _save_name: String;
        private var _save_data: String;
        private var _save_empty: Boolean;
        private var _json: JSON;
        private var _data_root: JSON; 
        private var _user_defaults: UserDefault; // = CCUserDefault.sharedUserDefault();

        public function SaveGame(savekey: String)
        {
            _save_key = "" + savekey;
            //_save_key = savekey.toString();
            Console.print("Initialising a savegame for key " + _save_key);
            _user_defaults = UserDefault.sharedUserDefault();
            Console.print("trying initial string fetch");
            _save_data = _user_defaults.getStringForKey(string(_save_key), "default");
            Console.print("finished initial fetch");
            if (_save_data == "default")
            {
                Console.print("erasing");
                //erase_data();
            }
            else
            {
                _save_empty = false;
            }
            Console.print("checking savegame name"); 
            //_save_name = _user_defaults.getStringForKey(_save_key + "_name");
            Console.print("Opened savegame: " + _save_name);
        }

        private function decode_data(): void
        {
            _json.loadString(_save_data);
            _data_root = _json.getObject("root");
        }

        public function erase_data(): void
        {
            Console.print("Erasing data");
            _save_data = "";
            _save_name = "Empty";
            _user_defaults.setStringForKey(_save_key, _save_data);
            _user_defaults.setStringForKey(_save_key + "_name", _save_name);
            _save_empty = true;
            Console.print("Finished saving data");
        }

        public function update_data(data: Dictionary.<String, Object>, name: String)
        {
            _user_defaults.setStringForKey(_save_key + "_name", name);
            var rootObj: JSON = new JSON();
            
            //test of getting dict elements
            var d = new Dictionary.<String, Object>();
            d["hello"] = "Thing";
            d["world"] = "Other";
    
            for (var k in d)
            {
                Console.print(k + " : " + d[k]);
            }


        }

        public function get_name(): String
        {
            return _save_name;
        }

        public function get_data(): String
        {
            return _save_data;
        }

        public function is_empty(): Boolean
        {
            return _save_empty;
        }
    }

    //Singleton for persistence manager.
    public class PersistenceManager
    {
        private static var pInst: PersistenceManager = null;
        private var user_defaults: UserDefault;
        private var slots: int;
        private var save_games: Vector.<SaveGame>;

        private function PersistenceManager()
        {
            Console.print("initialising Persistence Manager");
            slots = Constants.SAVEGAME_SLOTS;
            user_defaults = UserDefault.sharedUserDefault();
            //user_defaults.purgeSharedUserDefault();
            /*
            Console.print(user_defaults.getStringForKey("hello", "hello default"));
            Console.print(user_defaults.getStringForKey("world", "world default"));
            Console.print(user_defaults.getStringForKey("hel_lo", "hel_lo default"));
            Console.print(user_defaults.getStringForKey("hel_lo" + 0, "hel_lo0 default"));
            Console.print(user_defaults.getStringForKey("hel_lo_" + 0, "hel_lo_0 default"));
            Console.print(user_defaults.getStringForKey("glyf_savegame_" + 0, "glyf_savegame_0 default"));
            */
            
            //For some reason the CCUserDefaults doesn't like
            //it if the key ends in a zero. I don't understand.
            save_games = new Vector.<SaveGame>();
            for (var i: int = 0; i < slots; i++)
            {
                var sg:SaveGame = new SaveGame(Constants.SAVEGAME_PREFIX + i);
                save_games.push(sg);
            }
            Console.print("finished initialising Persistence Manager");
        }

        public function newSave(slot: int, name: String)
        {
        }

        public function eraseSave(slot: int)
        {
            save_games[slot].erase_data();
        }

        public function updateSave(slot: int)
        {
            Debug.print("serialise game state into slot " + slot);
        }

        public function loadSave(slot: int)
        {
            Debug.print("deserialise game state from slot " + slot);
        }

        public static function getInstance(): PersistenceManager
        {
            if (!pInst)
            {
                pInst = new PersistenceManager();
            }
            return pInst;
        }
    }
}
