package com.rockethands
{
    import loom2d.events.Event;
    import loom2d.events.Touch;
    import loom2d.events.TouchEvent;
    import loom2d.events.TouchPhase;

    import loom2d.math.Point;
    import loom2d.math.Rectangle;

    delegate DirectionSensorCallback(direction: Point) : void;

    public class MovementSensor
    {
        public var samples: Vector.<Point>; 
        public var on_sense_direction: DirectionSensorCallback;
        private var needs_clearing: Boolean;
        private var dir: Point;

        public function MovementSensor()
        {
            samples = new Vector.<Point>();
            on_sense_direction = new DirectionSensorCallback();
            reset();
        }

        public function reset()
        {
            trace("resetting movement sensor");
            needs_clearing = false;
            samples.clear();
            dir.x = 0;
            dir.y = 0;
        }

        public function addSample(p: Point)
        {
            if (!needs_clearing)
            {    
                samples.push(p);
                if (samples.length >=3)
                {
                    var totalx = samples[0].x - samples[samples.length-1].x;
                    var totaly = samples[0].y - samples[samples.length-1].y;

                    if (Math.abs(totalx) > Math.abs(totaly))
                    {
                        dir.y = 0;
                        if (totalx < 0)
                            dir.x = 1;
                        else
                            dir.x = -1;
                    }
                    else
                    {
                        dir.x = 0;
                        //it is a vertical move
                        if (totaly < 0)
                            dir.y = 1;
                        else
                            dir.y = -1;
                    }

                    on_sense_direction(dir);
                    needs_clearing = true;
                }
            }
        }
    }

}
