package dungeonsofdestiny.game
{
    import loom2d.animation.Juggler;
    import loom2d.display.Image;
    import loom2d.display.DisplayObjectContainer;
    import loom2d.animation.Juggler;
    import loom2d.Loom2D;
    import loom2d.textures.Texture;

    import dungeonsofdestiny.game.RoomTile;
    import dungeonsofdestiny.game.Room;

    class DungeonEntityMove
    {
        public var dir_x: int;
        public var dir_y: int;
        public var tile: DungeonEntity;
    }

    class DungeonEntity extends RoomTile
    {
        protected var _queued_move: DungeonEntityMove;
        protected var _has_move_queued: Boolean;
        public var blocked_last_turn: Boolean;

        public function DungeonEntity(juggler: Juggler, room: Room)
        {
            super(juggler, room);
            _queued_move = new DungeonEntityMove();
            blocked_last_turn = false;
        }

        public function get_queued_move() : DungeonEntityMove
        {
            if (_has_move_queued)
                return _queued_move;
            else
                return null;
        }

        public function clear_queued_move()
        {
            _has_move_queued = false;
        }

        public function queue_move(xdir: int, ydir: int)
        {
            _queued_move.dir_x = xdir;
            _queued_move.dir_y = ydir;
            _queued_move.tile = this;
            _has_move_queued = true;
        }

    }

}
