package dungeonsofdestiny.game.enemies
{
    import loom2d.animation.Juggler;
    import loom2d.display.Image;
    import loom2d.display.DisplayObjectContainer;
    import loom2d.animation.Juggler;
    import loom2d.Loom2D;
    import loom2d.textures.Texture;

    import dungeonsofdestiny.game.RoomTile;
    import dungeonsofdestiny.game.Room;
    import dungeonsofdestiny.game.DungeonEntity;
    import dungeonsofdestiny.game.DungeonEntityMove;
    import loom2d.ui.TextureAtlasManager;
    import types.TileEffect_t;
    import loom2d.math.Point;


    class Enemy extends DungeonEntity
    {

        protected var _mydir: Point = new Point(0, 1);
        
        public function Enemy(juggler: Juggler, room: Room)
        {
            super(juggler, room);
            effect += TileEffect_t.DAMAGE;
            effect += TileEffect_t.BLOCK;
        }

        public function take_turn(players_move: Point)
        {
            //Enemy turns are based on
            //1. Their position / blocked status
            //2. Player position / movement
            //_players_move = _room.get_player_move();
            //_players_move = new Point(1, 1);

        }

        public function die()
        {
            Console.print("Removing enemy from room enemies");
            _room.enemies.remove(this);
            super.die();
        }
    }

    class Scorpion extends Enemy
    {
        public function Scorpion(juggler: Juggler, room: Room)
        {
            super(juggler, room);
            set_texture(TextureAtlasManager.getTexture("tiles", "scorpion1"));   
        }

        public function take_turn(players_move: Point)
        {
            super.take_turn(players_move);
            //Do exactly what the player does
            //submit_move(_players_move.x, _players_move.y);
            queue_move(players_move.x, players_move.y);
        }
    }

    class Spider extends Enemy
    {
        public function Spider(juggler: Juggler, room: Room)
        {
            super(juggler, room);
            set_texture(TextureAtlasManager.getTexture("tiles", "spider1"));
            _mydir.x = 0;
            _mydir.y = 1;
        }
        public function take_turn(players_move: Point)
        {
            super.take_turn(players_move);
            //Do exactly what the player does
            //submit_move(_players_move.x, _players_move.y);
            if (blocked_last_turn)
                _mydir.y = -_mydir.y;
            queue_move(_mydir.x, _mydir.y);
            blocked_last_turn = false;
        }

    }

    class Wasp extends Enemy
    {

        public function Wasp(juggler: Juggler, room: Room)
        {
            super(juggler, room);
            set_texture(TextureAtlasManager.getTexture("tiles", "wasp1"));
            _mydir.x = 1;
            _mydir.y = 0;
        }
        public function take_turn(players_move: Point)
        {
            super.take_turn(players_move);
            if (blocked_last_turn)
                _mydir.x = -_mydir.x;
            queue_move(_mydir.x, _mydir.y);
            blocked_last_turn = false;
        }

    }

    class Demon extends Enemy
    {   
        public function Demon(juggler: Juggler, room: Room)
        {
            super(juggler, room);
            set_texture(TextureAtlasManager.getTexture("tiles", "demon1"));
            _mydir.x = 1;
            _mydir.y = 1;
        }

        public function take_turn(players_move: Point)
        {
            super.take_turn(players_move);
            if (blocked_last_turn)
                _mydir.x = -_mydir.x;
            queue_move(_mydir.x, _mydir.y);
            blocked_last_turn = false;
        }

    }



}
