package dungeonsofdestiny.game
{
    import types.TileEffect_t;
    
    import loom2d.animation.Juggler;
    import loom2d.display.Image;
    import loom2d.display.DisplayObjectContainer;
    import loom2d.animation.Juggler;
    import loom2d.Loom2D;
    import loom2d.textures.Texture;


    import dungeonsofdestiny.game.Room;


    class RoomTile
    {
        protected var _juggler: Juggler;
        protected var _room: Room;
        protected var _room_layer: RoomLayer;
        public var tx: int;
        public var ty: int;
        public var tw: int;
        public var th: int;
        public var display_image: Image;
        public var effect: int = 0;

        
        public function RoomTile(juggler: Juggler, room: Room)//, tx: int, ty: int)
        {
            this._juggler = juggler;
            _room_layer = null;
            //this.tx = tx;
            //this.ty = ty;
            //this.tw = tw;
            //this.th = th;
            this._room = room;
            display_image = new Image();
            //Console.print("Tile image width: " + tw + ", height: " + th);
            //container.addChild(display_image);
            //reset_position();
        }

        public function set_room_layer(lyr: RoomLayer)
        {
            _room_layer = lyr;
        }

        public function die() 
        {
            _room_layer.remove_tile(this);
            Console.print("Is there some cleanup I have to do when killing an object?");
        }
    
        
        public function set_texture(tex: Texture)
        {
            display_image.texture = tex;
            display_image.width = _room.tile_width;
            display_image.height = _room.tile_height;
        }

        public function reset_position(gridx: int = -1, gridy: int = -1)
        {
            if (gridx == -1)
                gridx = this.tx;
            if (gridy == -1)
                gridy = this.ty;
            //remove all tweens from the image
            Loom2D.juggler.removeTweens(display_image);
            tx = gridx;
            ty = gridy;
            display_image.x = _room.get_x_position(tx);
            display_image.y = _room.get_y_position(ty);
        }

        public function move(distx: int, disty: int)
        {
            _room_layer.move_tile(this, distx, disty);
        }

    }
}
