package views
{
    import loom.sound.Listener;
    import loom.sound.Sound;
    import loom2d.events.Event;
    import loom2d.animation.Juggler;
    import loom2d.textures.Texture;
    import loom2d.display.Image;
    import loom2d.display.DisplayObject;
    import loom2d.display.DisplayObjectContainer;
    import loom2d.display.Stage;
    import loom2d.events.Touch;
    import loom2d.events.TouchEvent;
    import loom2d.events.TouchPhase;
    import loom.platform.Mobile;
    import loom.platform.UserDefault;


    import loom2d.ui.SimpleLabel;
    import feathers.controls.Button;
    import feathers.controls.Label;
    import feathers.display.OffsetTiledImage;

    import com.rockethands.View;
    import com.rockethands.ViewCallback;
    import constants.Constants;
    import system.platform.Platform;
    import system.platform.PlatformType;

    class TitleView extends View
    {
        [Bind] public var title: Label;
        [Bind] public var subtitle: Label;
        [Bind] public var creditsBtn: Button;

        public var on_start: ViewCallback;
        public var on_credits: ViewCallback;

        
        public function init(lml: String = null, hstyle: String = null, vstyle: String = null)
        {

            // Setup anything else, like UI, or game objects.
            var bg = new Image(Texture.fromAsset("assets/images/bg.png"));
            bg.width = Constants.GAMEWIDTH;//init_stage.stageWidth;
            bg.height = Constants.GAMEHEIGHT; //init_stage.stageHeight;
            addChild(bg);
            
            
            super.init(lml, hstyle, vstyle);
            
            //title.center();
            //subtitle.center();
            title.y = 50;
            subtitle.y = 400;
            
            if (Platform.getPlatform() != PlatformType.ANDROID)
            {
                subtitle.text = "Click or Space\nto start!";
            }
            else
            {
                subtitle.text = "Tap to start!";
            }
            title.center();

            //title.x = Constants.GAMEWIDTH / 2 - title.width/2;
            //subtitle.x = Constants.GAMEWIDTH / 2 - subtitle.width/2;
            Console.print("title width is :" + title.bounds.width);
            
            /*
            var sprite = new Image(Texture.fromAsset("assets/images/logo.png"));
            sprite.center();
            sprite.x = 50;//stage.stageWidth / 2;
            sprite.y = 50;//stage.stageHeight / 2 + 50;
            addChild(sprite);

            var label = new SimpleLabel("assets/fonts/Curse-hd.fnt");
            label.text = "Hello Loom!";
            label.center();
            label.x = 50;//stage.stageWidth / 2;
            label.y = 50;//stage.stageHeight / 2 - 100;
            addChild(label);
            */
        }

        public function enter(owner:DisplayObjectContainer)
        {
            super.enter(owner);
            stage.addEventListener(TouchEvent.TOUCH, touch);
        }

        public function exit()
        {
            stage.removeEventListener(TouchEvent.TOUCH, touch);
            super.exit();
        }

        private function touch(e:TouchEvent)
        {
            if (e.target == creditsBtn) {
                on_credits();
                return;
            }
            if (e.touches[0].phase == TouchPhase.BEGAN) on_start();
        }

        public function tick(){}
        public function render(){}
        
    }

}
